
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Oracle中的sql语句优化 / iVAN</title>

    <meta name="description" content="Oracle中的sql语句优化 1.选择最有效率的表名顺序(只在基于规则的优化器中有效)ORACLE的解析器按照从右到左的顺序处理FROM子句中的表名,FROM子句中写在最后的表(基础表driving table)将被最先处理,在FROM子句中包含多个表的情况下,必须选择记录条数最少的表作为基础表.如果有3个以上的表连接查询,那就需要选择交叉表(intersection table)作为基础表 , 交叉表是指那个被其他表所引用的表. 2.WHERE子句中的连接顺序ORACLE采用自下而上的顺序解析WHERE子句,根据这个原理表">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Oracle中的sql语句优化</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><strong>1、选择最有效率的表名顺序(只在基于规则的优化器中有效)<br /></strong>ORACLE的解析器按照<strong>从右到左</strong>的顺序处理FROM子句中的表名，FROM子句中写在最后的表(基础表driving table)将被最先处理，在FROM子句中包含多个表的情况下，必须选择记录条数最少的表作为基础表。如果有3个以上的表连接查询，那就需要选择交叉表(intersection table)作为基础表 , 交叉表是指那个被其他表所引用的表。</p>
<p><strong>2、WHERE子句中的连接顺序<br /></strong>ORACLE采用自下而上的顺序解析WHERE子句，根据这个原理表之间的连接必须写在其他WHERE条件之前，那些可以过滤掉最大数量记录的条件必须写在WHERE子句的末尾。</p>
<p><strong>3、SELECT子句中避免使用*<br /></strong>ORACLE在解析的过程中，会将*依次转换成所有的列名，这个工作是通过查询数据字典完成的，这意味着将耗费更多的时间。</p>
<p><strong>4、减少访问数据库的次数<br /></strong>ORACLE在内部执行了许多工作 ：解析SQL语句，估算索引的利用率，绑定变量，读数据块等。</p>
<p><strong>5、重新设置arraysize</strong></p>
<p>在SQL*Plus、SQL*Forms和Pro*C中重新设置ARRAYSIZE参数，可以增加每次数据库访问的检索数据量，建议值为200。</p>
<p><strong>6、使用 DECODE 函数来减少处理时间<br /></strong>使用DECODE函数可以避免重复扫描相同记录或重复连接相同的表。</p>
<p><strong>7、整合简单、无关联的数据库访问<br /></strong>如果你有几个简单的数据库查询语句 , 你可以把它们整合到一个查询中 ( 即使它们之间没有关系 )</p>
<p><strong>8、删除重复记录<br /></strong>最高效的删除重复记录方法(因为使用了ROWID)例子：<br />
DELETE  FROM  EMP E  WHERE  E.ROWID &gt; (SELECT MIN(X.ROWID) FROM  EMP X  WHERE  X.EMP_NO = E.EMP_NO);</p>
<p><strong>9、用TRUNCATE替代DELETE<br /></strong>当删除表中的记录时，在通常情况下，回滚段(rollback segments)用来存放可以被恢复的信息。如果没有COMMIT事务，ORACLE会将数据恢复到删除之前的状态(准确地说是恢复到执行删除命令之前的状况)。而当运用TRUNCATE时，回滚段不再存放任何可被恢复的信息。当命令运行后数据不能被恢复。因此很少的资源被调用，执行时间也会很短，TRUNCATE 只在删除全表适用，TRUNCATE是DDL不是DML。</p>
<p><strong>10、尽量多使用 COMMIT<br /></strong>只要有可能在程序中尽量多使用COMMIT，这样程序的性能得到提高，需求也会因为COMMIT所释放的资源而减少。<br />
COMMIT所释放的资源： <br />
a. 回滚段上用于恢复数据的信息 <br />
b. 被程序语句获得的锁 <br />
c. redo log buffer中的空间 <br />
d. ORACLE为管理上述3种资源中的内部花费</p>
<p><strong>11、用Where子句替换HAVING子句<br /></strong>避免使用HAVING子句，HAVING只会在检索出所有记录之后才对结果集进行过滤，这个处理需要排序，总计等操作。如果能通过WHERE子句限制记录的数目，那就能减少这方面的开销。on、where、having这三个都可以加条件的子句中，on是最先执行，where次之，having最后，因为on是先把不符合条件的记录过滤后才进行统计，它就可以减少中间运算要处理的数据，按理说应该速度是最快的，where也应该比having快点的，因为它过滤数据后才进行sum，在两个表联接时才用on的，所以在一个表的时候，就剩下where跟having<br />
 比较了。在这单表查询统计的情况下，如果要过滤的条件没有涉及到要计算字段，那它们的结果是一样的，只是where可以使用rushmore技术，而having就不能，在速度上后者要慢。如果要涉及到计算的字段，就表示在没计算之前，这个字段的值是不确定的，根据上篇写的工作流程，where的作用时间是在计算之前就完成的，而having就是在计算后才起作用的，所以在这种情况下，两者的结果会不同。在多表联接查询时，on比where更早起作用。系统首先根据各个表之间的联接条件，把多个表合成一个临时表后，再由where 进行过滤，然后再计算，计算完后再由having进行过滤。由此可见，要想过滤条件起到正确的作用，首先要明白这个条件应该在什么时候起作用，然后再决定放在那里。</p>
<p><strong>12、减少对表的查询<br /></strong>在含有子查询的SQL语句中，要特别注意减少对表的查询。例子：<br />
SELECT TAB_NAME FROM TABLES WHERE (TAB_NAME,DB_VER) = ( SELECT TAB_NAME,DB_VER  FROM  TAB_COLUMNS   WHERE  VERSION = 604)</p>
<p><strong>13、通过内部函数提高SQL效率<br /></strong>复杂的SQL往往牺牲了执行效率。能够掌握上面的运用函数解决问题的方法在实际工作中是非常有意义的。</p>
<p><strong>14、使用表的别名(Alias)<br /></strong>当在SQL语句中连接多个表时，请使用表的别名并把别名前缀于每个Column上。这样一来就可以减少解析的时间并减少那些由Column歧义引起的语法错误。</p>
<p><strong>15、用EXISTS替代IN、用NOT EXISTS替代NOT IN<br /></strong>在许多基于基础表的查询中，为了满足一个条件，往往需要对另一个表进行联接。在这种情况下，使用EXISTS(或 NOT EXISTS)通常将提高查询的效率。在子查询中NOT IN子句将执行一个内部的排序和合并。无论在哪种情况下NOT IN都是最低效的(因为它对子查询中的表执行了一个全表遍历)。为了避免使用NOT IN，我们可以把它改写成外连接(Outer Joins) 或NOT EXISTS。<br />
(高效) SELECT * FROM  EMP WHERE EMPNO&gt;0 AND EXISTS (SELECT 1 FROM DEPT WHERE DEPT.DEPTNO = EMP.DEPTNO AND LOC = 'MELB')<br />
(低效) SELECT * FROM  EMP WHERE EMPNO&gt;0 AND DEPTNO IN (SELECT DEPTNO FROM DEPT WHERE LOC = 'MELB')</p>
<p><strong>16、识别“低效执行”的SQL语句<br /></strong>虽然目前各种关于SQL优化的图形化工具层出不穷，但是写出自己的SQL工具来解决问题始终是一个最好的方法<br />
SELECT  EXECUTIONS , DISK_READS, BUFFER_GETS, <br />
ROUND ((BUFFER_GETS-DISK_READS)/BUFFER_GETS,2 ) Hit_radio, <br />
ROUND (DISK_READS/EXECUTIONS,2) Reads_per_run, <br />
SQL_TEXT <br />
FROM  V$SQLAREA <br />
WHERE  EXECUTIONS&gt;0 <br />
AND  BUFFER_GETS &gt; 0 <br />
AND  (BUFFER_GETS-DISK_READS)/BUFFER_GETS &lt; 0.8 <br />
ORDER BY 4 DESC ;</p>
<p><strong>17、用索引提高效率<br /></strong>索引是表的一个概念部分，用来提高检索数据的效率，ORACLE使用了一个复杂的自平衡B-tree结构。通常通过索引查询数据比全表扫描要快，当ORACLE找出执行查询和Update语句的最佳路径时，ORACLE优化器将使用索引。同样在联结多个表时使用索引也可以提高效率，另一个使用索引的好处是它提供了主键(primary key)的唯一性验证。那些LONG或LONG RAW 数据类型，你可以索引几乎所有的列。通常在大型表中使用索引特别有效。当然在扫描小表时，使用索引同样能提高效率。虽然使用索引能得到查询效率提高<br />
 , 但是也必注意到它的代价。索引需要空间来存储，也需要定期维护，每当有记录在表中增减或索引列被修改时，索引本身也会被修改。这意味着每条记录的INSERT、DELETE、UPDATE 将为此多付出4、5次的磁盘I/O。因为索引需要额外的存储空间和处理，那些不必要的索引反而会使查询反应时间变慢。定期的重构索引是有必要的：<br />
ALTER  INDEX &lt;INDEXNAME&gt; REBUILD &lt;TABLESPACENAME&gt;。</p>
<p><strong>18、用EXISTS替换DISTINCT<br /></strong>当提交一个包含一对多表信息(比如部门表和雇员表)的查询时，避免在SELECT子句中使用 DISTINCT。一般可以考虑用EXIST替换，EXISTS使查询更为迅速，因为RDBMS核心模块将在</p>
<p>子查询的条件一旦满足后，立刻返回结果。<br />
(低效) SELECT DISTINCT DEPT_NO,DEPT_NAME FROM DEPT D , EMP E WHERE  D.DEPT_NO = E.DEPT_NO<br />
(高效) SELECT DEPT_NO,DEPT_NAME FROM DEPT D WHERE EXISTS (SELECT 'X' FROM  EMP E WHERE  E.DEPT_NO = D.DEPT_NO);</p>
<p><strong>19、sql语句用大写的</strong></p>
<p>因为oracle总是先解析sql语句，把小写的字母转换成大写的再执行。</p>
<p><strong>20、在java代码中尽量少用连接符"+"连接字符串</strong></p>
<p><strong>21、避免在索引列上使用NOT　<br /></strong>NOT会产生在和在索引列上使用函数相同的影响。当ORACLE遇到NOT，就会停止使用索引转而执行全表扫描。</p>
<p><strong>22、避免在索引列上使用计算<br /></strong>WHERE子句中，如果索引列是函数的一部分，优化器将不使用索引而使用全表扫描。 <br />
(低效)SELECT name FROM DEPT WHERE SAL * 12 &gt; 25000; <br />
(高效)SELECT name FROM DEPT WHERE SAL &gt; 25000/12;</p>
<p><strong>23、用&gt;=替代&gt;<br /></strong>(高效)SELECT * FROM  EMP  WHERE  DEPTNO &gt;=4 <br />
(低效)SELECT * FROM  EMP  WHERE DEPTNO &gt; 3 <br />
两者的区别在于，前者DBMS将直接跳到第一个DEPT 等于4的记录，而后者将首先定位到DEPTNO = 3的记录并且向前扫描到第一个DEPT大于3的记录。</p>
<p><strong>24、用UNION替换OR(适用于索引列)<br /></strong>通常情况下用UNION替换WHERE子句中的OR将会起到较好的效果。对索引列使用OR将造成全表扫描。注意以上规则只针对多个索引列有效。如果有column没有被索引, 查询效率可能会因为你没有选择OR而降低。在下面的例子中LOC_ID和REGION上都建有索引。<br />
(高效)<br />
SELECT LOC_ID,LOC_DESC,REGION <br />
FROM LOCATION <br />
WHERE LOC_ID = 10 <br />
UNION <br />
SELECT LOC_ID,LOC_DESC,REGION <br />
FROM LOCATION <br />
WHERE REGION = 'MELBOURNE'<br />
(低效) <br />
SELECT LOC_ID,LOC_DESC,REGION <br />
FROM LOCATION<br />
WHERE LOC_ID = 10 OR REGION = 'MELBOURNE' <br />
如果坚持要用OR，那就需要返回记录最少的索引列写在最前面。</p>
<p><strong>25、用IN来替换OR  <br /></strong>这是一条简单易记的规则，但是实际的执行效果还须检验，在ORACLE8i下两者的执行路径似乎是相同的．　<br />
(低效) SELECT * FROM LOCATION WHERE LOC_ID = 10 OR LOC_ID = 20 OR LOC_ID = 30 <br />
(高效) SELECT * FROM LOCATION WHERE LOC_IN IN (10,20,30);</p>
<p><strong>26、避免在索引列上使用 IS NULL 和 IS NOT NULL<br /></strong>避免在索引中使用任何可以为空的列，ORACLE将无法使用该索引。对于单列索引，如果列包含空值，索引中将不存在此记录。对于复合索引，如果每个列都为空，索引中同样不存在此记录。如果至少有一个列不为空，则记录存在于索引中。举例：如果唯一性索引建立在表的A列和B列上，并且表中存在一条记录的A、B值为(123,null)，ORACLE将不接受下一条具有相同A、B值(123,null)的记录插入。然而如果所有的索引列都为空，ORACLE将认为整个键值为空而空不等于空，因此你可以插入1000条具有相同键值的记录，当然它们都是空。因为空值不存在于索引列中，所以WHERE子句中对索引列进行空值比较将使ORACLE停用该索引。<br />
(低效、索引失效) <br />
SELECT * FROM  DEPARTMENT  WHERE  DEPT_CODE IS NOT NULL; <br />
(高效、索引有效) <br />
SELECT * FROM  DEPARTMENT  WHERE  DEPT_CODE &gt;= 0;<br />
或者可以用 &gt;= ''</p>
<p><strong>27、总是使用索引的第一个列<br /></strong>如果索引是建立在多个列上，只有在它的第一个列(leading column)被where子句引用时，优化器才会选择使用该索引。这也是一条简单而重要的规则，当仅引用索引的第二个列时，优化器使用了全表扫描而忽略了索引。</p>
<p><strong>28、用UNION-ALL替换UNION (如果有可能的话)<br /></strong>当SQL语句需要UNION两个查询结果集合时，这两个结果集合会以UNION-ALL的方式被合并 , 然后在输出最终结果前进行排序。如果用UNION ALL替代UNION，这样排序就不是必要了。效率就会因此得到提高，需要注意的是，UNION ALL将重复输出两个结果集合中相同记录。因此各位还是要从业务需求分析使用UNION ALL的可行性，UNION将对结果集合排序，这个操作会使用到 SRT_AREA_SIZE这块内存。对于这块内存的优化也是相当重要的，下面的SQL可以用来查询排序的消耗量。<br />
(低效) <br />
SELECT  ACCT_NUM, BALANCE_AMT <br />
FROM  DEBIT_TRANSACTIONS <br />
WHERE TRAN_DATE = '31-DEC-95' <br />
UNION <br />
SELECT ACCT_NUM, BALANCE_AMT <br />
FROM DEBIT_TRANSACTIONS <br />
WHERE TRAN_DATE = '31-DEC-95' <br />
(高效) <br />
SELECT ACCT_NUM, BALANCE_AMT <br />
FROM DEBIT_TRANSACTIONS <br />
WHERE TRAN_DATE = '31-DEC-95' <br />
UNION ALL <br />
SELECT ACCT_NUM, BALANCE_AMT <br />
FROM DEBIT_TRANSACTIONS <br />
WHERE TRAN_DATE = '31-DEC-95'</p>
<p><strong>29、用WHERE替代ORDER BY<br /></strong>ORDER BY 子句只在两种严格的条件下使用索引<br />
ORDER BY 中所有的列必须包含在相同的索引中并保持在索引中的排列顺序<br />
ORDER BY 中所有的列必须定义为非空<br />
WHERE 子句使用的索引和ORDER BY子句中所使用的索引不能并列</p>
<p>表DEPT包含以下列 <br />
DEPT_CODE PK NOT NULL <br />
DEPT_DESC NOT NULL <br />
DEPT_TYPE NULL<br />
(低效、索引不被使用) <br />
SELECT DEPT_CODE  FROM  DEPT   ORDER BY  DEPT_TYPE <br />
(高效、使用索引) <br />
SELECT DEPT_CODE  FROM  DEPT   WHERE  DEPT_TYPE &gt; 0</p>
<p><strong>30、避免改变索引列的类型<br /></strong>当比较不同数据类型的数据时，ORACLE自动对列进行简单的类型转换。假设EMPNO是一个数值类型的索引列 <br />
SELECT * FROM EMP  WHERE  EMPNO = '123' <br />
实际上经过ORACLE类型转换，语句转化为：SELECT * FROM EMP  WHERE  EMPNO = TO_NUMBER('123') <br />
幸运的是类型转换没有发生在索引列上，索引的用途没有被改变。<br />
 <br />
现在假设EMP_TYPE是一个字符类型的索引列<br />
SELECT * FROM EMP WHERE EMP_TYPE = 123 <br />
这个语句被ORACLE转换为 <br />
SELECT * FROM EMP WHERE TO_NUMBER(EMP_TYPE)=123 <br />
因为内部发生的类型转换，这个索引将不会被用到。为了避免ORACLE对你的SQL进行隐式的类型转换，最好把类型转换用显式表现出来。注意当字符和数值比较时，ORACLE会优先转换数值类型到字符类型。</p>
<p><strong>31、需要当心的WHERE子句<br /></strong>某些SELECT语句中的WHERE子句不使用索引  <br />
(1)'!='将不使用索引。记住索引只能告诉你什么存在于表中，而不能告诉你什么不存在于表中。<br />
(2)'||'是字符连接函数，就象其他函数那样，停用了索引。<br />
(3)'+'是数学函数，就象其他数学函数那样，停用了索引。<br />
(4)相同的索引列不能互相比较，这将会启用全表扫描。</p>
<p><strong>32、一些原则<br /></strong>a. 如果检索数据量超过30%的表中记录数，使用索引将没有显著的效率提高。 <br />
b. 在特定情况下，使用索引也许会比全表扫描慢，但这是同一个数量级上的区别。而通常情况下，使用索引比全表扫描要块几倍乃至几千倍。</p>
<p><strong>33、避免使用耗费资源的操作<br /></strong>带有DISTINCT、UNION、MINUS、INTERSECT、ORDER BY的SQL语句会启动SQL引擎 <br />
执行耗费资源的排序 (SORT) 功能。DISTINCT需要一次排序操作，而其他的至少需要执行两次排序。通常带有UNION、MINUS、INTERSECT的SQL语句都可以用其他方式重写。如果你的数据库的SORT_AREA_SIZE调配得好，使用UNION、MINUS、INTERSECT也是可以考虑的，毕竟它们的可读性很强。</p>
<p><strong>34、优化GROUP BY<br /></strong>提高GROUP BY语句的效率，可以通过将不需要的记录在GROUP BY之前过滤掉。下面两个查询返回相同结果但第二个明显就快了许多。<br />
(低效) <br />
SELECT JOB,AVG(SAL) <br />
FROM EMP <br />
GROUP JOB <br />
HAVING JOB = 'PRESIDENT' <br />
OR JOB = 'MANAGER' <br />
(高效)<br />
SELECT JOB,AVG(SAL) <br />
FROM EMP <br />
WHERE JOB = 'PRESIDENT' <br />
OR JOB = 'MANAGER' <br />
GROUP JOB</p>
<p>原帖地址：<a href="http://blog.csdn.net/myyate/article/details/3305052" rel="external nofollow noreferrer">http://blog.csdn.net/myyate/article/details/3305052</a></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 03:44:32</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/oracle/" title="oracle">oracle</a>, <a href="https://www.iamivan.net/tag/sql/" title="sql">sql</a>, <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>, <a href="https://www.iamivan.net/tag/%e7%b4%a2%e5%bc%95/" title="索引">索引</a>, <a href="https://www.iamivan.net/tag/%e6%8e%92%e5%ba%8f/" title="排序">排序</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Oracle中的sql语句优化的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pd64m3b.html" rel="bookmark">关联-关于oracle中查询sql的优化</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 关于oracle中查询sql的优化 在数据库中的某个表中有几百万条数据,现在要用这张表关联别的表去查询,查询速度很慢,如何优化才能使查询速度快一些. 解决方案 先优化SQL,然后再优化业务逻辑.最后优化数据库数据存储.起码得把SQL贴出来看看吧,几百万的数据不算多呀. 解决方案二: oracle的权值查询 解决方案三: 用一个相关联的ID,直接查那个表,这样就简单了!			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pLOK4vM.html" rel="bookmark">Oracle中解析SQL语句的过程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				为了将用户写的SQL文本转化为Oracle认识的且可执行的语句,这个过程就叫做解析过程.解析分为硬解析和软解析.一条SQL语句在第一次被执行时必须进行硬解析. 当客户端发出一条SQL语句(也可以是一个存储过程或者一个匿名PL/SQL块)进入shared pool时(注意,我们从前面已经知道,Oracle对这些SQL不叫做SQL语句,而是称为游标.因为Oracle在处理SQL时,需要很多相关的辅助信息,这些辅助信息与SQL语句一起组成了游标), Oracle首先将SQL文本转化为ASCII值,然后			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bKd9L7M.html" rel="bookmark">SQL Server中的SQL语句优化与效率问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				很多人不知道SQL语句在SQL SERVER中是如何执行的,他们担心自己所写的SQL语句会被SQL SERVER误解.比如: select * from table1 where name='zhangsan' and tID &gt; 10000 和执行: select * from table1 where tID &gt; 10000 and name='zhangsan' 一些人不知道以上两条语句的执行效率是否一样,因为如果简单的从语句先后上看,这两个语句的确是不一样,如果tID是一个聚合索引,那			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MNEaVWb.html" rel="bookmark">Oracle中PL&sol;SQL中if语句的写法介绍</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				以下是对Oracle中PL/SQL中if语句的写法进行了详细的分析介绍,需要的朋友可以过来参考下   复制代码 代码如下: /* If语句: 判断用户输入的数字. */ set serveroutput on --接收键盘输入 accept num prompt '请输入一个数字:'; declare   --将屏幕输入的数字付给变量   pnum number := # begin   if pnum = 0 then dbms_output.put_line('您输入的是0');   end			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MAXwkQb.html" rel="bookmark">oracle中使用SQL递归语句</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				场景:常见的领导关系树结构,知道某一节点ID,要查出此节点的所有下级(直接下级和间接下级),此时需要使用SQL递归语句. oracle中的递归语句:  start   with     connect   by   prior  . 例子:  pid  id   a   b     a   c       a   e     b   b1     b   b2     c   c1     e   e1     e   e3     d   d1         指定pid=a,选出     a			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pL5Aevz.html" rel="bookmark">sql语句优化之SQL Server&lpar;详细整理&rpar;&lowbar;MsSql</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				MS SQL Server查询优化方法 查询速度慢的原因很多,常见如下几种 1.没有索引或者没有用到索引(这是查询慢最常见的问题,是程序设计的缺陷) 2.I/O吞吐量小,形成了瓶颈效应. 3.没有创建计算列导致查询不优化. 4.内存不足 5.网络速度慢 6.查询出的数据量过大(可以采用多次查询,其他的方法降低数据量) 7.锁或者死锁(这也是查询慢最常见的问题,是程序设计的缺陷) 8.sp_lock,sp_who,活动的用户查看,原因是读写竞争资源. 9.返回了不必要的行和列 10.查询语句不好,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MyP3BEb.html" rel="bookmark">sql语句优化分享</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				sql语句优化分享 这是查询学生数据的逻辑,逻辑比较有点乱,这个查询跑30分钟也不会出结果,一执行CPU立马100%,虽然是个虚似机,但也不至于这种查询也对付不了,肯定有优化的地方.     SELECT  *        FROM 学生表 WITH(NOLOCK) WHERE          (FromSys IS NULL OR          (             (FromSys&lt;&gt;'A' AND FromSys&lt;&gt;'B' AND FromSys&lt;&gt;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pP2Xd8b.html" rel="bookmark">基于索引的SQL语句优化之降龙十八掌</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  From:www.oracle.com.cn 基于索引的SQL语句优化之降龙十八掌 1        前言        2 2        总纲        2 3        降龙十八掌        3第一掌避免对列的操作        3第二掌避免不必要的类型转换        4第三掌增加查询的范围限制        4第四掌尽量去掉&quot;IN&quot;.&quot;OR&quot;        4第五掌尽量去掉 &quot;&lt;&gt;&quot;        5第六			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mq8XKab.html" rel="bookmark">mysql-java中的sql语句为何会报错，而到了workbench就可以执行</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 java中的sql语句为何会报错,而到了workbench就可以执行 rt基本上是timestamp的格式,比如insert into table values ('2015-03-17 00:00:00');这句话在java通过jdbc执行就会报错,而直接在workbench下面操作就没有问题为什么会这样? 解决方案 可能是字符串单引号等引起的,打印代码中的字符串跟workbench中比较 解决方案二: insert into table(字段1,字段2....) value( 值1			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ybjwxNM.html" rel="bookmark" class="title">Unity引擎宣布抛弃Flash平台</a>
					<div>
						相信很多独立游戏以及移动游戏开发者都不会对Unity引擎感到陌生.今天,Unity公司CEO David Helgason发布消息称,游戏引擎Unity今后将不再支持Flash平台,且于今天起不再销售 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Nz7WjZz.html" rel="bookmark" class="title">CSS3&plus;HTML5特效3 - 纵向无缝滚动</a>
					<div>
						老惯例,先看例子. This is a test 1. This is a test 2. This is a test 3. This is a test 4. This is a test 5.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/apXQ1lz.html" rel="bookmark" class="title">以用户为中心的设计&colon;让用户觉得友好的网站</a>
					<div>
						文章描述:以用户为中心的设计:让用户觉得友好的网站. 不可否认,web的用途越来越广.大家在互联网上看资讯/电影.聊天.找朋友/工作.玩游戏.写小说/日志.交易/买卖.听音乐/广播.互联网已经不仅仅是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qMqKvKz.html" rel="bookmark" class="title">EL表达式详细解析</a>
					<div>
						&lt;%@ page isELIgnored=&quot;true&quot;%&gt; 表示是否禁用EL语言,TRUE表示禁止.FALSE表示不禁止.JSP2.0中默认的启用EL语言. JSTL  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDAWq0b.html" rel="bookmark" class="title">DevOps的各个阶段</a>
					<div>
						本文基于我在瑞典DevOpsDays上发表的&quot;DevOps是个阶段,而不是特定状态&quot;演说整理.如有兴趣 ,可以在线观看我的演说,不过在阅读本文时,无需事先观看. 在过去的几年里,我 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqLqQGb.html" rel="bookmark" class="title">WPF案例&lpar;三&rpar; 模拟QQ&OpenCurlyDoubleQuote;快速换装＂界面</a>
					<div>
						这个小程序使用Wpf模拟QQ快速换装页面的动画特效,通过使用组合快捷键Ctrl+Left或Ctrl+Right,可实现Image平滑的向左或者向右 滑动,页面如下,有兴趣的朋友可以下载源码:http: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M62J4NM.html" rel="bookmark" class="title">android数据存储方式&lpar;二&rpar; Shared Preferences</a>
					<div>
						android的数据存储有四种方式: 1.Shared Preferences 主要用于存储key-value对格式的 数据,是轻量级的存储机制,轻到只能存储基本数据类型. 2.Files 通过Fil ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5AEPnp.html" rel="bookmark" class="title">select中添加、修改、删除option元素</a>
					<div>
						&lt;!doctype html public &quot;-//w3c//dtd html 4.0 transitional//en&quot;&gt; &lt;html&gt; &lt;head ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7kL1Zz.html" rel="bookmark" class="title">PPT怎么制作类似卡通效果人物</a>
					<div>
						PPT怎么制作类似卡通效果人物   1.切换到&quot;插入&quot;选项卡,在&quot;图像&quot;组中选择&quot;图片&quot;,然后选择一张人物正面全身照插入. 2.选中插入的图 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgK2mOM.html" rel="bookmark" class="title">python通过定义一个类实例作为ftp回调方法</a>
					<div>
						  本文实例讲述了python通过定义一个类实例作为ftp回调方法.分享给大家供大家参考.具体实现方法如下: ? 1 2 3 4 5 6 7 8 9 10 11 12 class Writer: de ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLag3vz.html" rel="bookmark" class="title">Photoshop制作漂亮的蓝色流星</a>
					<div>
						  流星制作分为三个部分:首先用路径做出轮廓,并填充简单的纹理做出主体;然后用画笔加上尾部及中间的一些发散小颗粒;最后调色,渲染局部高光即可. 最终效果 &lt;点小图查看大图&gt; 1.新建一个1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQNmY0M.html" rel="bookmark" class="title">怎么用驱动精灵修复摄像头问题？</a>
					<div>
						  1.摄像头没有安装驱动或者安装了错误的驱动版本. 对于这种情况,用户可以通过驱动精灵提供的驱动安装升级功能,正确安装上合适的摄像头驱动就能解决. 2.很多免驱摄像头,本身不需要安装额外的驱动,只需 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b24ml3p.html" rel="bookmark" class="title">局域网内如何提高计算机网速</a>
					<div>
						如何提高网速貌似已成为了我们一致的需求,当让方法有很多,本文整理了一些,由此需求的朋友可以借鉴下,希望对大家有所帮助   1.去掉无关的选项 在Windows XP中,双击&quot;控制面板&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvGPa1p.html" rel="bookmark" class="title">为U盘安装个谷歌系统</a>
					<div>
						  U盘也能启动谷歌系统?不错,这就是传说中的chrome_os_usb. 解压下载的chrome_os_usb.zip文件,运行其中的Win32DiskImager.exe,如果遇到这个错误,忽略它 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd6nBXb.html" rel="bookmark" class="title">如何利用U盘给软件加密</a>
					<div>
						  有的软件开发商有这样一种需求,就是使用U盘发布软件的同时,想要节约成本,防止U盘中的软件被复制,但又不想再购买昂贵的加密狗,因此想要把软件绑定在U盘上执行,当U盘拔下来的时候,软件就不能正常运行, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLaNNvz.html" rel="bookmark" class="title">比尔盖茨对新任CEO挑选进度感到满意，谈鲍尔默离职哽咽</a>
					<div>
						[科技讯]11月20日消息,近期关于微软新任CEO的人选问题备受关注,在微软本周二举办的年度股东大会上,创始人比尔盖茨到场发表演讲,并表示目前对于微软新任CEO的挑选进度感到满意. 作为微软创始人,比 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXwPXKM.html" rel="bookmark" class="title">深入分析jquery解析json数据&lowbar;jquery</a>
					<div>
						我们先以解析上例中的comments对象的JSON数据为例,然后再小结jQuery中解析JSON数据的方法. JSON数据如下,是一个嵌套JSON: 复制代码 代码如下: {&quot;comment ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/My339Pz.html" rel="bookmark" class="title">C&num; MVC 如何加载默认checked的kendo treeview&comma; 远程json数据绑定？</a>
					<div>
						问题描述 C# MVC 如何加载默认checked的kendo treeview, 远程json数据绑定? C# MVC 如何加载默认checked的kendo treeview, 远程json数据绑 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mvrlm6M.html" rel="bookmark" class="title">mysql不重复插入所有字段值都一样的记录</a>
					<div>
						问题描述 mysql不重复插入所有字段值都一样的记录 怎么实现mysql避免插入重复所有字段值都一样的记录,不是根据某个主键的值来判断是否插入,只有在所有字段值都一样(已经存在)的时候才无法添加该记录 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE603PM.html" rel="bookmark" class="title">java代码-java中影院售票系统的思路</a>
					<div>
						问题描述 java中影院售票系统的思路 用java做一个影院售票系统,但是思路不是很清晰.感觉集合里面要嵌套类,类里面又有类.感觉很不清晰.哪位大神可以解答一下.说一下具体的思路也行 .当然要是有代码 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0R7NJz.html" rel="bookmark" class="title">如何绕过Edge补丁欺骗浏览器地址栏和恶意网址检测？</a>
					<div>
						本文讲的是如何绕过Edge补丁欺骗浏览器地址栏和恶意网址检测?,将大部分来源于本网站的漏洞都进行了修补.我很敬佩Edge的开发者以及它的安全研究员.对于那些想继续维持IE策略的开发者,我想你们应该至少 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPB02qb.html" rel="bookmark" class="title">python疑问有关 随机优化 和 回溯算法</a>
					<div>
						问题描述 python疑问有关 随机优化 和 回溯算法 据说以前比尔盖茨写了一个程序,就是全班里边只有他的座位四周是4个女生,其他人都不是.写一个这样的程序,要求输入教室里座位的行数和列数,男女生自动 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pL7kg0M.html" rel="bookmark" class="title">easyui-easyUI的div确定的一个区域，如何给这个区域添加滚动条</a>
					<div>
						问题描述 easyUI的div确定的一个区域,如何给这个区域添加滚动条 easyUI的div确定的一个区域,如何给这个区域添加滚动条,代码如下 &lt;div id=&quot;getpicture& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgwVmAM.html" rel="bookmark" class="title">r语言-R语言 问题 求救 求回答</a>
					<div>
						问题描述 R语言 问题 求救 求回答 朋友的考试题,主要是 345 题 求救 如果有答错的也请指出来 解决方案 R语言的一些问题R 语言乱码问题					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0Nlk8z.html" rel="bookmark" class="title">jQuery bind事件使用详解&lowbar;jquery</a>
					<div>
						使用jquery也有近1年了,今天在看国外大牛代码突然发现一个地方没看明白,代码如下 $(window).bind('load.jcarousel', function() { windowLoade ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAk02Zz.html" rel="bookmark" class="title">PHP统计二维数组元素个数的方法&lowbar;php实例</a>
					<div>
						解决思路1. 首先从数据库的congtent字段读取数据,并把它们合并成一个字符串. 复制代码 代码如下: &lt;?php while($myrow = $connector -&gt; fetch ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn8G9Kb.html" rel="bookmark" class="title">求助个WINFORM的问题如何取标题栏的高度边框的宽度啊</a>
					<div>
						问题描述 想让窗体内容部分刚好可以容下指定SIZE的panel,请问有办法么谢谢各位 解决方案 解决方案二:Form.Margin应该是边框宽度,解决方案三:form.ClientRectangle					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW7vBAM.html" rel="bookmark" class="title">输入错误时，如何实现继续输入</a>
					<div>
						问题描述 写一个根据输入整数求和的程序,如果输入999则程序求和后结束,如果输入小数,则显示&quot;输入数字格式不对,请重新输入&quot;.下面的程序不能实现重新输入,请问该怎么修改:impor ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXd2WAp.html" rel="bookmark" class="title">DEDECMS后台数据备份还原的应用&lowbar;dedecms</a>
					<div>
						备份 1安装DEDECMS(网站地址/install 开始安装) 2后台添加栏目-内容等(添加一些数据) 3后台更新全站为HTML(前台生成) 4后台备份数据库(开始备份) 5保留备份后的数据库 把此 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlAdLRp.html" rel="bookmark" class="title">奥运开幕之际乐途英国攻略颁奖现场网友激情四溢</a>
					<div>
						7月28日,正值2012年伦敦奥运会开幕之日,乐途旅游网在北京康源瑞廷酒店成功举办&quot;从北京到伦敦-英国旅游攻略争先赛&quot;颁奖仪式及英国旅游知识讲座有奖活动. 备受关注的英国旅游攻略争 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
